"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _util = require("./util");

const xxx = key => value => `${key}=${value && !(0, _util.isToken)(value) ? (0, _util.quote)(value) : value}`;

const build = params => {
  return params.reduce((prev, [key, values]) => {
    const transform = xxx(key);

    if (!(0, _util.isToken)(key)) {
      throw new TypeError();
    }

    if (Array.isArray(values)) {
      return [...prev, ...values.map(transform)];
    }

    return [...prev, transform(values)];
  }, []);
};

const challenge = (params, options) => {
  if (Array.isArray(params)) {
    return build(params);
  } else if (typeof params === 'object') {
    const entries = params;
    return challenge(Object.keys(params).map(key => [key, entries[key]]), options);
  }

  throw new TypeError();
};

var _default = (scheme, token, params) => {
  const obj = typeof scheme === 'string' ? {
    scheme,
    token,
    params
  } : scheme;

  if (typeof obj !== 'object') {
    throw new TypeError();
  } else if (!(0, _util.isScheme)(obj.scheme)) {
    throw new TypeError('Invalid scheme.');
  }

  return [obj.scheme, ...(typeof obj.token !== 'undefined' ? [obj.token] : []), ...(typeof obj.params !== 'undefined' ? challenge(obj.params) : [])].join(' ');
};

exports.default = _default;