"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.unquote = exports.quote = exports.isScheme = exports.isToken = void 0;
const token = /^[^\u0000-\u001F\u007F()<>@,;:\\"/?={}\[\]\u0020\u0009]+$/;

const isToken = str => typeof str === 'string' && token.test(str);

exports.isToken = isToken;
const isScheme = isToken;
exports.isScheme = isScheme;

const quote = str => `"${str.replace(/"/g, '\\"')}"`;

exports.quote = quote;

const unquote = str => str.substr(1, str.length - 2).replace(/\\"/g, '"');

exports.unquote = unquote;